// ---------------------------------------------------------------------

#include "bump_pattern_macro_log_internal.inc"















#macro define_customize_t_theta_h_spread_function(input_func)
    #declare f_customize_spread =
    function(year, theta, h) {
    input_func(year, theta, h)
    }

#end




/***************************************
*
* ݥHgenerate_thin_circled_pattern_func_by_blend_theta_chop() ͪfunction internalA
* btimeVOLAӬO@ mask function
*
* Φ theta V M r Vܤpattern
*
*
*
* 
* f_output(year, theta)
*
*
****************************************/

#macro generate_thin_circled_pattern_func_independent_of_h(
first_year, last_year, d_boundary_year0, d_boundary_year1, year_bump_size, partition_amount, // partition_amount >= 1A NyearƶqXA |ͦ partition_amountӨ
bump_size_along_theta, theta_pos_random_factor, //bump_size_along_theta jסA ΨӨDf_set C@theta_node_amount ,  0 < theta_pos_random_factor < 1 (valid)
seed_m,
r_vs_t, h_vs_r_ratio // provide addition info to macro , (r_vs_t * time) ~= r
)

    
    
    // f_set define
    #local f_using_internal_set = array[partition_amount];
    
    #local time_extent_pos = array[partition_amount + 1];
    #local time_interval = (last_year - first_year)/partition_amount;
    #for(i, 0, partition_amount)
        #local time_extent_pos[i] = first_year + i* time_interval;
    
    #end
    
    
// step 1. for each partition    
    
    #for(i, 0, partition_amount - 1)
        
        
// Step 1.1. generate theta chop pos and form the array "theta_pos_array"
    
        #local mid_time_pos = (time_extent_pos[i] + time_extent_pos[i+1])/2;
        #local effective_r = r_vs_t *mid_time_pos; // ΨӱQŦXbump_size_along_theta j׮ɡAthetanhnode ݥiiHi
        
        #local theta_node_amount = int(2*pi*effective_r/bump_size_along_theta);       
        #local avg_theta_interval = 2*pi/theta_node_amount;
        #local overall_theta_offset = (avg_theta_interval/2) *(1 - theta_pos_random_factor - 0.0001)* (2*rand(seed_m) - 1);
        
        
        #local theta_pos_array = array[theta_node_amount];
        
        #for(j, 0, theta_node_amount - 1)
            #local rand_num_a = rand(seed_m);
            #local theta_pos_array[j] = avg_theta_interval/2 + j* avg_theta_interval + theta_pos_random_factor*(2*rand_num_a - 1)* avg_theta_interval/2 + overall_theta_offset;
        #end
        
        
        
        
// Step 1.2. radial( infact + theta for more thin theta) bump function

        #local f_noise_apply_vs_year_impl =
        function(var_t, var_theta, var_random) {
        f_noise3d(var_t, var_theta, var_random)
        }
                
        
                
// Step 1.3. generate f_year_spread_array for each theta node

        #local year_mix_mode = 0;  // 0 multiple, 1 min
        
        #local f_year_spread_array = array[theta_node_amount];
        #for(j, 0, theta_node_amount - 1)
            #local rand_num_b = 2*rand(seed_m) - 1;
            #local rand_num_c = 2*rand(seed_m) - 1;
            #local fix_d_boundary_year0 = d_boundary_year0*(1 + 0.11*rand_num_b); // oӧ쪺0.11 M 0.16ᦳΨ
            #local fix_d_boundary_year1 = d_boundary_year1*(1 + 0.16*rand_num_c);
            
            
            #local f_year_spread_array[j] =
            function(var_t, h) { // ꥦMhL
            select(
                var_t - (time_extent_pos[i] - fix_d_boundary_year0/2),
                0,
                select(
                    var_t - (time_extent_pos[i] + fix_d_boundary_year0/2),
                    f_cos_blend_rise(var_t, time_extent_pos[i] - fix_d_boundary_year0/2 , time_extent_pos[i] + fix_d_boundary_year0/2),
                    select(
                        var_t - (time_extent_pos[i+1] - fix_d_boundary_year1/2),
                        1,
                        select(
                            var_t - (time_extent_pos[i+1] + fix_d_boundary_year1/2),
                            f_cos_blend_fall(var_t, time_extent_pos[i+1] - fix_d_boundary_year1/2, time_extent_pos[i+1] + fix_d_boundary_year1/2),
                            0
                        )
                        
                    )
                
                )
            )
            }
        #end
        
        
        
        
        
        
// Step 1.4. generate each partition function(year, theta, h)
        
        
        #local seed_m1 = seed(rand(seed_m)*100);
        #local theta_more_thin = no;
        #local more_thin_factor = 2.0; // Ӥtheta}CCӤd򦳴Xbumps ܤ
        
        
        
        #local f_using_internal_set[i] = generate_thin_circled_pattern_func_by_blend_theta_chop(
        year_bump_size, theta_pos_array,
        f_year_spread_array,
        function(theta) {1},
        f_noise_apply_vs_year_impl, year_mix_mode,
        theta_more_thin, more_thin_factor,
        seed_m1
        );
        
        
        
        
        #undef f_noise_apply_vs_year_impl
        #undef f_year_spread_array
        
    #end
    
    
    
    #local t_extent_max = max(d_boundary_year0*1.16, d_boundary_year1*1.16);
    
    
// Step 2. join each partition function(year, theta, h) to single function(year, theta)

    #local output_f = 
    function(var_t, theta) {
    select(
        var_t - (time_extent_pos[0] - t_extent_max/2),
        0,
        select(
            var_t - (time_extent_pos[0] + t_extent_max/2),
            0 + f_using_internal_set[0](var_t, theta, 0),
            
            #for(i, 1, partition_amount)
            select(
                var_t - (time_extent_pos[i] - t_extent_max/2),
                f_using_internal_set[i-1](var_t, theta, 0),
                    select(
                    var_t - (time_extent_pos[i] + t_extent_max/2),
                    f_using_internal_set[i-1](var_t, theta, 0)     #if(i <= partition_amount-1) + f_using_internal_set[i](var_t, theta, 0) #end,
            #end
                    select(
                        var_t - (time_extent_pos[partition_amount] + t_extent_max/2),
                        f_using_internal_set[partition_amount-1](var_t, theta, 0) + 0,
                        0
                    )
        #for(i, 0, partition_amount)
        ))
        #end
    
    }
    
    
    
    
    
    
    output_f






#end




/***************************************
*
* ݥHgenerate_thin_circled_pattern_func_by_blend_theta_chop() ͪfunction internalA
* btimeVOLAӬO@ mask function
*
* Φ theta V M r VM hVܤpattern
*
*
*
* 
* f_output(year, theta, h)
*
*
****************************************/

#macro generate_thin_circled_pattern_func(
first_year, last_year, d_boundary_year0, d_boundary_year1, year_bump_size, partition_amount, // partition_amount >= 1A NyearƶqXA |ͦ partition_amountӨ
bump_size_along_theta, theta_pos_random_factor, //bump_size_along_theta jסA ΨӨDf_set C@theta_node_amount ,  0 < theta_pos_random_factor < 1 (valid)
min_h, max_h, d_boundary_h0, d_boundary_h1, h_bump_size,
seed_m,
r_vs_t, h_vs_r_ratio // provide addition info to macro , (r_vs_t * time) ~= r
)

    
    
    // f_set define
    #local f_using_internal_set = array[partition_amount];
    
    #local time_extent_pos = array[partition_amount + 1];
    #local time_interval = (last_year - first_year)/partition_amount;
    #for(i, 0, partition_amount)
        #local time_extent_pos[i] = first_year + i* time_interval;
    
    #end
    
    
// step 1. for each partition    
    
    #for(i, 0, partition_amount - 1)
        
        
// Step 1.1. generate theta chop pos and form the array "theta_pos_array"
    
        #local mid_time_pos = (time_extent_pos[i] + time_extent_pos[i+1])/2;
        #local effective_r = r_vs_t *mid_time_pos; // ΨӱQŦXbump_size_along_theta j׮ɡAthetanhnode ݥiiHi
        
        #local theta_node_amount = int(2*pi*effective_r/bump_size_along_theta);       
        #local avg_theta_interval = 2*pi/theta_node_amount;
        #local overall_theta_offset = (avg_theta_interval/2) *(1 - theta_pos_random_factor - 0.0001)* (2*rand(seed_m) - 1);
        
        
        #local theta_pos_array = array[theta_node_amount];
        
        #for(j, 0, theta_node_amount - 1)
            #local rand_num_a = rand(seed_m);
            #local theta_pos_array[j] = avg_theta_interval/2 + j* avg_theta_interval + theta_pos_random_factor*(2*rand_num_a - 1)* avg_theta_interval/2 + overall_theta_offset;
        #end
                
        
        
// Step 1.2. radial( infact + theta for more thin theta) bump function

        #local f_noise_apply_vs_year_impl =
        function(var_t, var_theta, var_random) {
        f_noise3d(var_t, var_theta, var_random)
        }
        

        
        
// Step 1.3. generate f_year_and_h_spread_array for each theta chop

        #local year_and_h_mix_to_year_and_theta_mode = 0;  // 0 multiple,  1 min,  2 debug (only f_year_and_h_spread_array)
        #local year_and_h_mix_mode = 0;  // 0 only f_year_mask,  1 with random chop h bumps,  2 with smooth angular shape(experiment),  3 with year-h space bumps,  4 customize
        #ifdef(f_customize_spread)
            #local year_and_h_mix_mode = 4;
        #end
        
        #local f_year_and_h_spread_array = array[theta_node_amount];
        #for(j, 0, theta_node_amount - 1)
            #local rand_num_b = 2*rand(seed_m) - 1;
            #local rand_num_c = 2*rand(seed_m) - 1;
            #local rand_num_d = 0.8 + 0.4*rand(seed_m);
            #local rand_num_e = rand(seed_m);
            #local fix_d_boundary_year0 = d_boundary_year0*(1 + 0.11*rand_num_b); // oӧ쪺0.11 M 0.16ᦳΨ
            #local fix_d_boundary_year1 = d_boundary_year1*(1 + 0.16*rand_num_c);
            
            
            
            
            #local f_year_mask =
            function(var_t) {
            select(
                var_t - (time_extent_pos[i] - fix_d_boundary_year0/2),
                0,
                select(
                    var_t - (time_extent_pos[i] + fix_d_boundary_year0/2),
                    f_cos_blend_rise(var_t, time_extent_pos[i] - fix_d_boundary_year0/2 , time_extent_pos[i] + fix_d_boundary_year0/2),
                    select(
                        var_t - (time_extent_pos[i+1] - fix_d_boundary_year1/2),
                        1,
                        select(
                            var_t - (time_extent_pos[i+1] + fix_d_boundary_year1/2),
                            f_cos_blend_fall(var_t, time_extent_pos[i+1] - fix_d_boundary_year1/2, time_extent_pos[i+1] + fix_d_boundary_year1/2),
                            0
                        )
                        
                    )
                
                )
            )
            }
            
            #switch(year_and_h_mix_mode)
                #case(0)
                    #local f_year_and_h_spread_array[j] =
                    function(var_t, var_h) {
                    f_year_mask(var_t)
                    }
                #break;
                #case(1)
                    #local f_year_and_h_spread_array[j] =
                    function(var_t, var_h) {
                    f_year_mask(var_t)
                    *f_noise3d(var_h/(h_bump_size*rand_num_d), 0, 50*rand_num_e)
                    }
                #break;
                #case(2)
                    #local ttt = f_smooth_shape[2](theta_pos_array[j]);
                    #local f_year_and_h_spread_array[j] =
                    function(var_t, var_h) {
                    f_year_mask(var_t)
                    //*f_noise3d(var_h/(h_bump_size*1), 0, 50 + ttt)
                    *(ttt - 0.85)*6.6666
                    *(0.1 + 0.9*f_noise3d(var_t/(year_bump_size*0.89), 0, var_h/(h_bump_size*0.94) + 76*rand_num_d) )
                    //*(0.2 + 0.8*f_noise3d(var_h/(h_bump_size*rand_num_d), 0, 0))
                    *(0.8 + 0.2*f_noise3d(0, 0, 50*rand_num_e) )
                    }
                #break;
                #case(3)
                    #local f_year_and_h_spread_array[j] =
                    function(var_t, var_h) {
                    f_year_mask(var_t)
                    *f_noise3d(var_t/year_bump_size, 0, var_h/(h_bump_size))
                    }
                #break;
                #case(4)
                    #local f_year_and_h_spread_array[j] =
                    function(var_t, var_h) {
                    f_year_mask(var_t)
                    *f_customize_spread(var_t, theta_pos_array[j], var_h)
                    }
                #break;
            #end
            
            
            
            #undef f_year_mask
        #end        

        
// Step 1.4. generate each partition function(year, theta, h)
        
        
        #local seed_m1 = seed(rand(seed_m)*100);
        #local theta_more_thin = yes;
        #local more_thin_factor = 1.0; // Ӥtheta}CCӤd򦳴Xbumps ܤ
        
        
        
        #local f_using_internal_set[i] = generate_thin_circled_pattern_func_by_blend_theta_chop(
        year_bump_size, theta_pos_array,
        f_year_and_h_spread_array,
        function(theta) {1},
        f_noise_apply_vs_year_impl, year_and_h_mix_to_year_and_theta_mode,
        theta_more_thin, more_thin_factor,
        seed_m1
        );
        
        
        
        
        #undef f_noise_apply_vs_year_impl
        #undef f_noise_apply_vs_h_impl
        #undef f_year_and_h_spread_array
                
    #end
    
    
// Step 2. join each partition function to f_pattern_mockup(year, theta, h)
    
    #local t_extent_max = max(d_boundary_year0*1.16, d_boundary_year1*1.16);
    
    
    
    #local f_pattern_mockup = 
    function(var_t, theta, h) {
    select(
        var_t - (time_extent_pos[0] - t_extent_max/2),
        0,
        select(
            var_t - (time_extent_pos[0] + t_extent_max/2),
            0 + f_using_internal_set[0](var_t, theta, h),
            
            #for(i, 1, partition_amount)
            select(
                var_t - (time_extent_pos[i] - t_extent_max/2),
                f_using_internal_set[i-1](var_t, theta, h),
                    select(
                    var_t - (time_extent_pos[i] + t_extent_max/2),
                    f_using_internal_set[i-1](var_t, theta, h)     #if(i <= partition_amount -1) + f_using_internal_set[i](var_t, theta, h) #end,
            #end
                    select(
                        var_t - (time_extent_pos[partition_amount] + t_extent_max/2),
                        f_using_internal_set[partition_amount-1](var_t, theta, h) + 0,
                        0
                    )
        #for(i, 0, partition_amount)
        ))
        #end
    
    }
    
// Step 3. combine f_pattern_mockup(year, theta, h) with f_height_mask
//         to f_output
    #local h_mask_mode = 1; // 0 multiple, 1 min
    
    
    
    #local f_height_mask =
    function(h) {
    select(
        h - min_h,
        0,
        select(
            h - (min_h + d_boundary_h0),
            f_parbl_step_rise(h, min_h, min_h + d_boundary_h0),
            select(
                h - (max_h - d_boundary_h1),
                1,
                select(
                    h - max_h,
                    f_parbl_step_fall(h, max_h - d_boundary_h1, max_h),
                    0
                )
                
            )
        
        )
    )
    }    
    #local f_output =
    function(var_t, theta, h) {
    #switch(h_mask_mode)
        #case(0)
            f_pattern_mockup(var_t, theta, h),
            *f_height_mask(h)
        #break;
        #case(1)
            f_imitate_min_r1_5(
                f_pattern_mockup(var_t, theta, h),
                f_height_mask(h)
            )
        #break;
    #end
    }
    
    
    #undef f_customize_spread
        
            
    f_output






#end



